/***************************************************************************
                          kgutenbook.h  -  description
                             -------------------
    begin                : Wed Nov 24 00:25:13 MST 1999
    copyright            : (C) 1999 & 2000 by llornkcor
    email                : llornkcor@llornkcor.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KGUTENBOOK_H
#define KGUTENBOOK_H

#include "multiline_ex.h"
#include <kapp.h>
#include <kconfig.h>
#include <keditcl.h>
#include <kfm.h>
#include <kfontdialog.h>
#include <klocale.h>
#include <ktreelist.h>
#include <kurllabel.h>
#include <qarray.h>
#include <qbuffer.h>
#include <qclipboard.h>
#include <qcolor.h>
#include <qcombobox.h>
#include <qdatetime.h>
#include <qdialog.h>
#include <qdir.h>
#include <qfiledialog.h>
#include <qfileinfo.h>
#include <qfont.h>
#include <qlabel.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qmessagebox.h>
#include <qpaintdevicemetrics.h>
#include <qpainter.h>
#include <qpalette.h>
#include <qprinter.h>
#include <qpushbutton.h>
#include <qrect.h>
#include <qregexp.h>
#include <qscrollview.h>
#include <qstatusbar.h>
#include <qstrlist.h>
#include <qstrlist.h>
#include <qtableview.h>
#include <qtextstream.h>
#include <qwidget.h>


//////////////////////////////////////


class Kgutenbook : public QWidget
{
  Q_OBJECT
public:

		void initKDialog();
    /** construtor */
    Kgutenbook(QWidget* parent=0, const char *name=0);
    /** destructor */
    ~Kgutenbook();
    KConfig	*config;
   	QPushButton* qtarch_DownloadButton;
 		QPushButton* qtarch_LibraryButton;
		QPushButton* qtarch_OpenButton;
		QPushButton* qtarch_ForwardButton;
		QPushButton* qtarch_BackButton;
		QPushButton* qtarch_PrintButton;
		QPushButton* qtarch_SearchButton;
		QPushButton* dictionaryButton;		
		QPushButton* qtarch_ExitButton;						
//		QPushButton* qtarch_SearchButton;
//		QPushButton* qtarch_ExitButton;
		QPushButton* FontButton;
		QPushButton* ClearButton;		
		QPushButton* lastBmkButton;
		QPushButton* setBookmarkButton;		
		QPushButton* qtarch_HelpButton;
		KApplication* kgutenbook;
 QFont font;			
		MultiLine_Ex* m_Left_Text;
		MultiLine_Ex* m_Right_Text;
    QPrinter *printer;
		KEdSrch *srchdialog;

    QLabel* StatusBar;
    QLabel* InfoBar;
 QString statusTop;
		QString pattern;
    QString status;
		QString file_name;
		QString listItemNumber;
		QString listItemFile;
		QString listItemYear;
		QString listItemTitle;
    QString brow;
		QString ftp_host;
		QString ftp_base_dir;
		QString index;
		QString local_index;
		QString local_library;
		QString title;
		int check;
		int lineCheck;
		int i_pageNum;
		int pages;		
	
		char host[1024];
		char login[1024];
		char password[1024];
		bool loadCheck;

    void 	Search();
    int direction;
		int	repeatSearch();
		bool setTitle();
		bool getTitle( const char *file);
		void AdjustStatus();
		void ResizeEdits();
public slots:
    void search_slot();
    void searchdone_slot();
    bool setStatus();
    bool checkFTP();
    bool downloadFtpList();
private slots:
		bool load( const char *fileName );
		void resizeEvent( QResizeEvent * );
private:
    int 	last_search;

protected slots:
    virtual void DownloadIndex();
		virtual void PrintBtn();
		virtual void SearchBtn();
		virtual void ForwardBtn();
	  virtual void BackBtn();
    virtual void LibraryBtn();
    virtual void OpenBtn();
    virtual void HelpBtn();
    virtual void ChangeFont();
    virtual bool Bookmark();
    virtual void setBookmark();
    virtual void LookupBtn();
    virtual void ClearEdit();
    virtual void ByeBye();
//    virtual void RightText();
protected:
  int doSearch(QString s_pattern, bool case_sensitive, bool forward, int line, int col );
    void keyPressEvent( QKeyEvent * );
    void keyReleaseEvent( QKeyEvent *e);
    QColor colors[2];

 /* bool regex,*/

};

#endif
